% LFDest.m: estimate % improvement in LFD.
% Usage: out = lfdest(inputValue, rr);
%
% inputValue is the number to be converted.
% rr = 1 returns 'out' as Estimated % Improvement in LFD.
%    = 2 returns 'out' as Estimated Post-Op LFD.
%    = 3 returns 'out' as Estimated % Improvement in, and Post-Op, LFD.
%
% Alternatively, you can simply type "lfdest" and follow the prompts
% To plot the function, use 'LFDestplot'
% Written by LF Dell'Osso on 4/9/09
% Last modified: 4/9/09 by LF Dell'Osso


function out = lfdest(inpVal, rr)

if nargin == 0
   inpVal=-1;
   verbose=1;
 elseif nargin == 1
     disp(' LFDest requires either 2 arguments (LFDpre, 1-3) or none')
 return
    else
    verbose=0;
end

while(nargin == 0) | (nargin == 2)
 if nargin < 2
   disp(' 0) Quit')
   disp(' 1) Convert Pre-Op LFD to Estimated % Improvement in LFD')
   disp(' 2) Convert Pre-Op LFD to Estimated Post-Op LFD')
   disp(' 3) Convert Pre-Op LFD to Estimated % Improvement in, and Post-Op, LFD')
   rr = input(' --> ');
 end

   switch rr
    case 0
       disp('aborting')
    return
    case 1
      if nargin == 0
      lfd_pre = input('Enter the Pre-Op LFD: ');
       else
        lfd_pre = inpVal;
      end
       if lfd_pre>=37.5
       disp(' LFD_pre must be less than 37.5 deg')
       return
       end
       
        while (lfd_pre<37.5)
      
       lfd_impr = round(-119.26*log(lfd_pre) +431.81);
        
         if verbose
          disp(['  % LFD Improvement estimated to be ' num2str(lfd_impr, '%4.0f') ' %'])
          return
         end
        out = lfd_impr;
        return
        end
       
    case 2         
      if nargin == 0
      lfd_pre = input('Enter the Pre-Op LFD: ');
       else
        lfd_pre = inpVal;
      end
       if lfd_pre>=37.5
       disp(' LFD_pre must be less than 37.5 deg')
       return
       end
       
        while (lfd_pre<37.5)
 
        lfd_post = round((-119.26*log(lfd_pre) +431.81)*(lfd_pre)/100 + lfd_pre);
       
         if verbose
          disp(['  % Post-Op LFD estimated to be ' num2str(lfd_post, '%4.0f') ' deg'])
          return
         end
        out = lfd_post;
        return
        end

    case 3
      if nargin == 0
      lfd_pre = input('Enter the Pre-Op LFD: ');
       else
        lfd_pre = inpVal;
      end
       if lfd_pre>=37.5
       disp(' LFD_pre must be less than 37.5 deg')
       return
       end
       
        while (lfd_pre<37.5)

        lfd_impr = round(-119.26*log(lfd_pre) +431.81);
        lfd_post = round((-119.26*log(lfd_pre) +431.81)*(lfd_pre)/100 + lfd_pre);
       
         if verbose
          disp(['  % LFD Improvement estimated to be ' num2str(lfd_impr, '%4.0f') ' %'])
          disp(['  % Post-Op LFD estimated to be ' num2str(lfd_post, '%4.0f') ' deg'])
          return
         end
        out(1) = lfd_impr;
        out(2) = lfd_post;
        return
        end

    otherwise
     disp([num2str(rr) ' is not a valid choice'])
     
   end  %% switch rr
end
