% snel2log.m: convert between Snellen and logMAR.
% Usage: out = snel2log(func, inputValue);
% where func = 1 converts Snellen to logMAR
%            = 2 converts logMAR to Snellen
% inputValue is the number to be converted.
% Alternatively, you can simply type "snel2log" and follow the prompts

% Written by:  Jonathan Jacobs
%              May 1999  (last mod: 05/22/99)

function out = snel2log(func, inpVal)

if nargin == 0
   func = -1;
   inpVal=-100;
   verbose=1;
 else
   verbose=0;
end

while(func<1) | (func>2)
   disp(' 1) Convert Snellen to logMAR')
   disp(' 2) Convert logMAR to Snellen')
   func = input(' --> ');
end

if func == 1
   snellen=inpVal;
   while (snellen<=0) | (snellen>4)
      snellen = input('Enter the Snellen visual acuity: ');
   end
   logMAR = log10(1/snellen);
   if verbose
      disp(['  the logMAR equivalent is ' num2str(logMAR)])
   end
   if nargout == 1
      out = logMAR;
   end
 else
   logMAR=inpVal;
   while (logMAR<-1.0) | (logMAR>1.5)
      logMAR = input('Enter the logMAR value: ');
   end
   snellen = 10^-logMAR;
   if verbose
      disp(['  the Snellen equivalent is ' num2str(snellen)])
   end
   denom=20/snellen;
   if verbose
      disp(['  (20/' num2str(denom) ')'])
   end
   if nargout == 1
      out = snellen;
   end
end
