% startup.m:   execute when MATLAB starts up.
%                1) Run 'OMpath' to add OMtools directories to path
%                2) Move to OMtools main directory

% Written by:  Jonathan Jacobs
%              December 1995 - March 2003  (last mod: 03/21/03)

% 21 Mar 2003: added '/' as sep character for MATLAB 6.5 (OS X, yay!)

function startup( null )

global dataroot OMroot

[comp, maxsize] = computer;
vers=version;
P = path;
if comp(1) == 'M' & vers(1)<='5' % 'classic' Mac OS
   sep  = ':';                   % between dirs in a single path
   sep2 = ';';                   % between path entries
 elseif comp(1) == 'P'           % PC
   sep  = '\'; 
   sep2 = ';';
 else                            % Unix (including Mac OS X)
   sep  = '/';
   sep2 = ':'; 
end   

%rootdrive = [strtok(matlabroot,sep) sep];

% generally 'OMroot' will just be the MATLAB directory,
% but you can change it to whatever suits your needs.
% This could be useful if you need to run MATLAB 4 and MATLAB 5
% and only want to have one OMtools installation.  
eval( ['cd ' '''' matlabroot '''' ;] )
if exist('omprefs','dir')==7
   ;
 else
   disp('"omprefs" directory missing from MATLAB directory.')
   disp('I will try to create it.')
   mkdir('omprefs')
end    

cd('omprefs')   
OMrootfid = fopen( 'OMroot.txt', 'r' );
if OMrootfid > 0
   OMroot = fread(OMrootfid);
   OMroot = setstr(OMroot');
   OMroot = strtok(OMroot,[10 13]);
   OMroot = deblank(OMroot);
   fclose(OMrootfid);
 else
   fid=fopen('OMroot.txt','w');
   fwrite(fid, '', 'char');
   fclose(fid);
   OMroot = 'null';
   disp('<<<startup.m>>>')
   disp('"OMroot.txt" missing from "MATLAB" directory.')
   disp('New file created.')
end

% find 'OMpath' in 'datadirs'
dirErr=0;
eval( ['cd ' '''' OMroot  sep 'OMtools' sep 'datadirs' '''' ;],['dirErr=1;'] )
if dirErr
   disp('  ')
   disp('<<<startup.m>>>')
   disp('OMtools directory error found:')
   disp('The directory specified in "OMroot.txt" is invalid');
   disp('It must specify the directory that contains "OMtools"');
   disp('and its subdirectories.  Typically this will just be');
   disp('in the directory "omprefs" in your "MATLAB" directory.')
   disp('You can either:')
   disp('Check the file "OMroot.txt" in your root "MATLAB" directory');
   disp('and verify that the path specified there is correct.');
   disp('  ...or...' )
   yorn=lower(input('Would you like to look for the "OMtools" directory (y/n)? ','s'));
   if yorn == 'y'
      [a,b]=uigetfile('contents.txt','Look for "contents.txt" in "OMtools"');
      sepList=findstr(b,sep);
      OMroot = b(1:sepList(length(sepList)-1)-1);
      eval(['cd ' '''' matlabroot ''''])
      cd('omprefs')
      fid=fopen('OMroot.txt','w');
      fwrite(fid, OMroot, 'char');
      fclose(fid);
      disp('"OMroot.txt" reinitialized.  Cross your fingers.')
      disp(' ')
    else
      disp('For the time being, I will try to set the OMtools root')
      disp('directory to be your "MATLAB" root.  (This may not work.)')
      OMroot=matlabroot;   
   end
end

eval( ['cd ' '''' OMroot sep 'OMtools' sep 'datadirs' ''''] )
eval( ['ompath'] )
eval( ['ergpath'] )

colordef none