% setdata.m:  Click on a data object and set its x, y, or z data.
% Usage: setdata( which, newdata );
% Where 'which' = 'x', 'y', 'z' or any combination.
% example: setdata('xy', 0.5, 1.0) will move a point to (0.5, 1.0)

% Written by:  Jonathan Jacobs
%              July 1997 - August 1997 (last mod:  08/27/97)

function setdata(which, newData1, newData2, newData3);

type = get(gco,'Type');

if ~strcmp(type, 'line')
   disp('You must click on a data object before running "SETDATA."')
   return
end

if ~isstr(which)
   disp('You must enter a string (e.g. ''x'', ''xy'') as your first argument.')
end

if nargin < 2
   help setdata
end

olddata = get(gco, [which(1) 'data']);

if size(newData1) ~= size(olddata)
   disp(['New data must be same size as old data: ' mat2str(size(olddata))])
   return
end
   
for k=1:length(which);
   eval(['newdata = newData' num2str(k) ';']); 
   set(gco, [which(k) 'data'], newdata);
end