% shrink.m:   Scale figure down by input value
% Usage: shrink(x), where 'x' is the percent of the figure window that
% the figure axis should use.  Hint: try 0.75 to start
% For SINGLE-AXIS figures only

% Written by:  Jonathan Jacobs
%              May 2000  (last mod: 05/24/00)


function shrink(pctX, pctY)

isMac=0; isHose=0;
comp = computer;
if lower(comp(1)) == 'm'
   isMac=1;
 else
   isHose=1;
end

if isempty(get(0,'Child'))
   disp('Nothing to shrink, dink.')
   return
end

if nargin == 1
   pctY = pctX;
end

if pctX > 1, pctX=1; end
if pctY > 1, pctY=1; end

gf = findHotW;
if gf == -1;
   disp('No valid plot window found.  Possible reasons:')
   disp(' * You don''t have a figure window open.')
   disp(' * You are trying to edit a Zoomtool window.')
   disp(' * I am having a nervous breakdown.')
   return
end

if strcmp( get(gf,'Tag'), 'EditingWindow')
   disp( 'Bring a graph window to the front and try again.')
   return
end

% Will need to look for ALL axes in the window and adjust accordingly
% I'll get to it later, maybe.

maxX = 0.95;
maxY = 0.9;
x_orig = (maxX-maxX*pctX)/2 + 0.025;
y_orig = (maxY-maxY*pctY)/2 + 0.05;
x_size = pctX;
y_size = pctY;

set(gca,'units','normalized')
set(gca,'pos',[x_orig y_orig x_size y_size])
