% shrinky.m: de-gargantuanize big-assed figures by decimating the data.
% Decimation factors of 2-10 are OK for printing figures.
% A decimation factor of x means "use every n-th sample."
% Usage: shrinky(decfact)

% Written by:  Jonathan Jacobs
%              March 2001  (last mod: 03/24/01)

function shrinky(decfact)

if nargin==0
   decfact = 0;
   while (decfact<1)
      decfact = input('Enter data decimation factor: ');
   end
end

axlist = get(gcf,'Children');
for a = 1:length(axlist)
	% find all the objects in the axis
	ga = axlist(a);
	children = get(ga,'children');

	% Find the handles for the lines
	chillen = length(children);
	linelist=[];
	otherlist=[];
	for i=1:chillen
	   if strcmp(get(children(i),'Type'),'line')
	      linelist=[linelist; children(i)];
	   end
	end

	linlen  = length(linelist);

	for j=1:linlen

	   oldXDat = get(linelist(j),'XData'); xlen=length(oldXDat);
	   oldYDat = get(linelist(j),'YData'); ylen=length(oldYDat);

	   if xlen > 100
	      newXDat = oldXDat(1:decfact:xlen);   
	      newYDat = oldYDat(1:decfact:ylen);
	      set(linelist(j),'XData',newXDat);   
	      set(linelist(j),'YData',newYDat);
	   end
	   
	end
end
