% yankdata.m:  Click on a data object and extract its x, y, or z data.
% NOTE: All existing data will be copied, even beyond the current x-axis limits.
% If you want to copy only the data shown in the existing limits, use 'yankdata_vis'.
% Usage: out = yankdata( whichdata );
% Where whichdata = 'x', 'y', 'z' or a combination (e.g. 'xy') .
% If no input argument is given, YANKDATA will prompt for input.
% EXAMPLE: To extract both x and y data -- [x,y]=yankdata('xy');

% Written by:  Jonathan Jacobs
%              June 1997 - June 2000 (last mod:  06/20/00)

function [out1, out2, out3] = yankdata(which);

if isempty(gco)
   disp('You must click on a figure''s data object before running "YANKDATA."')
   return
end

if nargin == 0 & nargout == 0 
   help yankdata
   return
end

type = get(gco,'Type');

if strcmp(type, 'line') | strcmp(type, 'surface') | strcmp(type, 'patch')
   ;
 else
   disp('You must click on a line, surface or patch before running "YANKDATA."')
   return
end

if nargin == 0
   which = '';
   while( which~='x' & which~='y' & which~='z' )
      which = lower(input('Yank x, y or z data? ','s'));
   end
end

which = lower(which);

for j=1:length(which)
   eval(['out' num2str(j) '= get(gco, ' '''' which(j) 'data'')'';']);
end