% zoomout.m:  zoom out on all 3 axis
% not for end user use; called by rotButt

% Written by: Jonathan Jacobs
%             January 1996 - July 2002 (last mod: 06/14/02)

% 6/14/02 -- converted from global variables to stored handles

function out = zoomout

rpFig=get(gco,'Parent');
rpH = get(rpFig,'USerData');
rpZoomOutH = rpH{20};

if rpZoomOutH
   h = get(rpZoomOutH, 'UserData');
 else
   h = gca;
end

%zoom out
rpXAxLims = get(h, 'XLim');
rpXAxLow  = rpXAxLims(1);
rpXAxHigh = rpXAxLims(2);
rpYAxLims = get(h, 'YLim');
rpYAxLow  = rpYAxLims(1);
rpYAxHigh = rpYAxLims(2);
rpZAxLims = get(h, 'ZLim');
rpZAxLow  = rpZAxLims(1);
rpZAxHigh = rpZAxLims(2);

rpXAxMid  =  (rpXAxLow + rpXAxHigh)/2;
rpXAxHigh =  rpXAxMid + 2*(rpXAxHigh - rpXAxMid);
rpXAxLow  =  rpXAxMid - 2*(rpXAxMid  - rpXAxLow);

rpYAxMid  =  (rpYAxLow + rpYAxHigh)/2;
rpYAxHigh =  rpYAxMid + 2*(rpYAxHigh - rpYAxMid);
rpYAxLow  =  rpYAxMid - 2*(rpYAxMid  - rpYAxLow);

rpZAxMid  =  (rpZAxLow + rpZAxHigh)/2;
rpZAxHigh =  rpZAxMid + 2*(rpZAxHigh - rpZAxMid);
rpZAxLow  =  rpZAxMid - 2*(rpZAxMid  - rpZAxLow);

set(h, 'XLim', [rpXAxLow rpXAxHigh]);
set(h, 'YLim', [rpYAxLow rpYAxHigh]);
set(h, 'ZLim', [rpZAxLow rpZAxHigh]);

out = [rpXAxLow rpXAxHigh rpYAxLow rpYAxHigh rpZAxLow rpZAxHigh];
