% fsbox.m: plot the foveal radius of +/- 0.5 degrees
% and the slip radius of +/- 4 deg/sec
% on top of an existing graph
% written by:  Jonathan Jacobs
%              April 1996 (last mod: 04/06/96)

% make sure there is reason to use fsbox
if isempty(get(gca, 'children'))
   disp( 'You should have a 2-D phase plane plot to use "fsbox".' )
   close
   return
end

fov = 0.5; slip = 4.0;

hold on
plot( [fov fov -fov -fov fov], [-slip slip slip -slip -slip],'r--')
%plot( [-fov  fov], [ slip  slip], 'r-');
%plot( [-fov  fov], [-slip -slip], 'r-');
%plot( [ fov  fov], [-slip  slip], 'r-');
%plot( [-fov -fov], [-slip  slip], 'r-');
%hold off

if ~exist('debugme') debugme = 0; end
if ~debugme
   clear fov slip
end
