function plthv

global rh rv lh lv st sv namelist

plthFigH = figure;
plthFigColor = get(plthFigH,'color');
if plthFigColor(1) >= 0.6     %% Light background
   lhColor = 'g';
   rhColor = 'b';
 elseif plthFigColor(1) < 0.6;
   lhColor = 'y';
   rhColor = 'c';
end

%lvColor = [.7 .5 0];
lvColor = lhColor;
rvColor = rhColor;

novrt=0;
if ~isempty(rv)
   t=maket(rv);
 elseif ~isempty(lv)
   t=maket(lv);
 else
   disp('No vertical data!?!')
   plth
   return
end

maxpt=max(max([lh,rh,lv,rv]));
minpt=min(min([lh,rh,lv,rv]));
maxt=max(t);

hold on
if ~isempty(lh)
   plot(t,lh,lhColor)
   lehH=text(maxt,maxpt-(maxpt-minpt)*.33,'LEH');
   set(lehH,'color', lhColor);
end   
if ~isempty(rh)
   plot(t,rh,rhColor)
   rehH=text(maxt,maxpt,'REH');
   set(rehH,'color', rhColor);
end   

if ~isempty(lv)
   plot(t,lv,'color',lvColor,'linestyle','--')
   levH=text(maxt,minpt,'LEV');
   set(levH,'color', lvColor);
end   
if ~isempty(rv)
   plot(t,rv,'color',rvColor,'linestyle','--')
   revH=text(maxt,maxpt-(maxpt-minpt)*.66,'REV');
   set(revH,'color', rvColor);
end

if ~isempty(st)
   plot(t,st,'r')
   rehH=text(maxt,maxpt,'H. Stim');
   set(rehH,'color', 'r');
end   
if ~isempty(sv)
   plot(t,sv,'r')
   rehH=text(maxt,maxpt,'V. Stim');
   set(rehH,'color', 'r');
end   

if exist('namelist','var')
   if ~isempty(namelist)
      title(nameclean(namelist));
   end
end
   
ept; dragger

%clear rehH lehH revH levH
%clear tempFigH tempFigColor lhColor lvColor rhColor rvColor