% mat2bin.m: MATLAB eye-data channel variables to a raw binary format ('.bin') file

% Written by:  Jonathan Jacobs
%              September 2013 (last mod: 09/12/13)


curdir = pwd;
ch=0; datalen=0;
rhflag=0; lhflag=0; rvflag=0; lvflag=0; stflag=0; svflag=0;

if exist('rh','var')
   rhflag=1;
   % put data into colum-major order
   [r,c]=size(rh);
   if r < c, rh=rh'; end
   [r,c]=size(rh);
   if datalen>0
      if r == datalen
         datasane = 1;
        else
         datasane = 0;
      end
     else 
      datalen=r;
   end   
   ch=ch+1;
end

if exist('lh','var')
   lhflag=1;
   % put data into colum-major order
   [r,c]=size(lh);
   if r < c, lh=lh'; end
   [r,c]=size(lh);
   if datalen>0
      if r == datalen
         datasane = 1;
        else
         datasane = 0;
      end
    else  
      datalen=r;
   end   
   ch=ch+1;
end

if exist('rv','var')
   rvflag=1;
   % put data into colum-major order
   [r,c]=size(rv);
   if r < c, rv=rv'; end
   [r,c]=size(rv);
   if datalen>0
      if r == datalen
         datasane = 1;
        else
         datasane = 0;
      end
    else  
      datalen=r;
   end   
   ch=ch+1;
end

if exist('lv','var')
   lvflag=1;
   % put data into colum-major order
   [r,c]=size(lv);
   if r < c, lv=lv'; end
   [r,c]=size(lv);
   if datalen>0
      if r == datalen
         datasane = 1;
        else
         datasane = 0;
      end
    else  
      datalen=r;
   end   
   ch=ch+1;
end

if exist('st','var')
   stflag=1;
   % put data into colum-major order
   [r,c]=size(st);
   if r < c, st=st'; end
   [r,c]=size(st);
   if datalen>0
      if r == datalen
         datasane = 1;
        else
         datasane = 0;
      end
    else  
      datalen=r;
   end   
   ch=ch+1;
end

if exist('sv','var')
   svflag=1;
   % put data into colum-major order
   [r,c]=size(sv);
   if r < c, sv=sv'; end
   [r,c]=size(sv);
   if datalen>0
      if r == datalen
         datasane = 1;
        else
         datasane = 0;
      end
    else  
      datalen=r;
   end   
   ch=ch+1;
end

if datasane == 0
   disp('There is a disagreement in the number of samples in the channels.  Please')
   disp('check the size of the "rh", "lh", "rv" and "lv" variables in the MATLAB workspace.')
   disp('Quitting.')
   return
end

data = [];
if rhflag, data = [data, rh]; end
if lhflag, data = [data, lh]; end
if stflag, data = [data, st]; end
if rvflag, data = [data, rv]; end
if lvflag, data = [data, lv]; end
if svflag, data = [data, sv]; end


disp(['I believe that there are ' num2str(ch) ' channels,'])
disp(['and there are ' num2str(datalen) ' samples per channel.'])
yorn = input('Do you agree (y/n)? ','s');

switch(yorn)
 case{'n','no'}
   disp('Aborting.  No conversion performed.')
   return
 case {'y','yes'}
    [fn,pn] = uiputfile('*.bin','Save this file as:');
    cfile = fn;
    %cfile = [fn '.bin'];
	eval(['cd ' '''' pn ''''])
	disp(['saving ' '''' pn cfile ''''])
	fid = fopen(cfile, 'w', 'l');
	fwrite(fid, data, 'float');
	fclose(fid);
   disp(['Converted file ' cfile ' written to ' pn])
end  

disp('Don''t forget to create an adjustbias file, if one does not already exist.')

cd(curdir)
