% rawBIN.m:    Standalone to read in raw binary (no header info) data files
% written by:  Jonathan Jacobs
%              March 2000  (last mod: 03/15/00)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% select a file to open
[filename, pathname] = uigetfile('', 'Load a data file');
if filename == 0   % hit the "Cancel" button
   disp( 'Cancelling.'); 
   omdir
   rdclear
   return;
end

disp( ' ' )
disp( [ 'Loading ' filename] )
exten = filename(find(filename=='.')+1:length(filename));

% open the binary file
[comp, maxsize] = computer;            
if comp(1) == 'M'
   fid = fopen( [pathname filename], 'r','l');
 else
   fid = fopen( [pathname filename], 'r' );
end

chan_count = 3;

% read in the data
datastart = 0;
fseek(fid, datastart, 'bof');
[tempdata, numsamps] = fread(fid,inf,'float32');
datlen = numsamps/chan_count;

fclose(fid);

format = lower(input('Is data (C)ontiguous or (I)interleaved? ','s'));
if format == 'c'
	% data stored as contiguous blocks
	for i = 1:chan_count
	   newdata(:,i) = tempdata( (i-1)*datlen+1: datlen*i);
	end
 else
	% data stored interleaved
	for i = 1:chan_count
	   ind = (0:datlen-1)*chan_count + i;
	   newdata(:,i) = tempdata(ind);
	end
end  

[dat_len, dat_cols] = size( newdata );
disp( ['  Channels found:     ' num2str(dat_cols)] );
disp( ['  Samples found:      ' num2str(dat_len)] );
