% swap_em.m:  called by movedata to swap file row/cols.
% written by: Jonathan Jacobs
%             May 1996

function [out] = swap_em(in, source, dest, numFiles, orientation )

[inR, inC] = size(in);

% 'dest' is the location that the 'source' data is to be placed BEFORE

% when info is organized along columns
% this includes a one-row vector  (i.e. 1 x n)
if( strcmp(orientation, 'col') )
   if source<dest
      out = [in(:, 1:source-1), in(:, source+1:dest-1),...
             in(:, source), in(:, dest:numFiles)];
    else
      out = [in(:, 1:dest-1), in(:, source),...
                in(:, dest:source-1), in(:, source+1:numFiles)];
   end
end   

% when info is organized along rows
% this includes a one-column vector  (i.e. n x 1)
if strcmp( orientation, 'row' )
   if source<dest
      out = [in(1:source-1,:); in(source+1:dest-1,:);...
             in(source,:); in(dest:numFiles,:)];
    else
      out = [in(1:dest-1,:); in(source,:);...
                in(dest:source-1,:); in(source+1:numFiles,:)];
   end
end