% pickpts.m:  displays normalized pos, vel, and acc traces on one graph.
% written by:  Jonathan Jacobs
%              February 1997  (last mod: 02/18/97)

if ~exist('pos')
   disp( 'You must use "PICKDATA" before running "PICKPTS"' )
   return
end

[nRows, nCols] = size(pos);
if nCols > 1
   disp( 'Use "PICKDATA" to select only ONE data trace.' )
   pickdata
   return
end

max_p = max(pos);  min_p = min(pos);
max_v = max(vel);  min_v = min(vel);
max_a = max(acc);  min_a = min(acc);

v_to_p = max_v/max_p;
if v_to_p > 15
   disp( 'vel/pos > 15')
end

a_to_p = max_a/max_p;
if a_to_p > 1500
   disp( 'acc/pos > 1500')
end

plot(acc/1000,'g');
hold on
plot(vel/10,'color', [1 0.5 0]);  % why doesn't anything rhyme with 'orange'?
plot(pos,'y');
plot( [1: length(pos)], zeros(length(pos),1), 'w' );
hold off

zoomtool

clear max_a min_a max_v min_v max_p min_
clear v_to_p a_to_p nRows nCols
