% tplot.m: Plot an array vs time
% usage: tplot(inputArray, startTime, sampling frequency)
% See also: SUB, SUBP

% Written by:  Jonathan Jacobs
%              February 1997  (last mod: 02/28/97)

function [plotH] = tplot(inp_array, startTime, samp_vect);
global samp_freq

if nargin == 0
   help tplot
   return
end

if nargin == 1
   startTime = 0;
end

if nargin <= 2
   samp_vect = samp_freq;
   if isempty(samp_vect) | (samp_vect == 0)
      while (isempty(samp_vect) | (samp_vect == 0)
         samp_vect = input( 'Enter the sampling frequency: ');
      end
   end
end

[numDRows,numDCols] = size( inp_array );
if (numDRows < numDCols)
   inp_array = inp_array';
   [numDRows,numDCols] = size( inp_array );
end

[numSFrqs] = length( samp_vect );

if numSFrqs ~= numDCols    % what do we do?
   tempSF = samp_vect(1);  % we'll make ALL samp freqs the same as 
   clear samp_vect         % 1st entry
   for i = 1:numDCols
      samp_vect(i) = tempSF;
   end
end

for x = 1: numDCols
   x_vect(:,x) = (1/samp_vect(x):1/samp_vect(x):numDRows/samp_vect(x))';
end
x_vect = x_vect + startTime;

plotH = plot(x_vect, inp_array);
xlabel( 'Time (seconds)' )
