% tts.m: Convert the time axis from Time To Samples
% Usage:  tts( sampFreq )
  
% Written by:  Jonathan Jacobs
%              April 1998 (last mod:  04/03/98)

function tts(sampFreq);

global samp_freq

if nargin == 0
   if isempty( samp_freq )
      samp_freq = 0;
   end
   if samp_freq == 0
      samp_freq = input('Enter the sampling frequency: ');
   end
end
sampFreq = samp_freq;

ga = gca;
gf = gcf;
if strcmp(get(gf,'Tag'), 'zoomed window')
   disp('tts can''t operate while ZOOMTOOL is active')
   return
end

temp = get(ga,'Children');

count=1;
for i=1:length(temp)
   if strcmp(get(temp(i),'Type'),'line')
      lineList(count)=temp(i);
      count = count+1;
   end
end

minX=1000000;
maxX=-1000000;
for i=1:length(lineList)
   x=get(lineList(i),'XData');
   x=x*sampFreq;
   minX=min(minX,min(x));
   maxX=max(maxX,max(x));
   set(lineList(i),'XData',x);
end

set(gca,'XLim', [minX maxX]);
