% xaxshift.m:  Shift all the data lines in an axis.
% Usage: xaxshift( howMuch );
% Where 'howMuch' is the amount to shift the data.  Positive values shift the data
% to the right; negative values shift the data to the left.

% Written by:  Jonathan Jacobs
%              April 1998 (last mod:  04/02/98)

function xaxshift(howMuch);

if nargin == 0
   help xaxshift
   return
end

figwind = findHotW;
figure(figwind)

ga = gca;
gf = gcf;

if strcmp(get(gf,'Tag'), 'zoomed window')
   disp('xAxShift can''t operate while ZOOMTOOL is active')
   return
end

temp = get(ga,'Children');

count=1;
for i=1:length(temp)
   if strcmp(get(temp(i),'Type'),'line')
      lineList(count)=temp(i);
      count = count+1;
   end
end

minX=1000000;
maxX=-1000000;
for i=1:length(lineList)
   x=get(lineList(i),'XData');
   x=x+howMuch;
   minX=min(minX,min(x));
   maxX=max(maxX,max(x));
   set(lineList(i),'XData',x);
end

set(gca,'XLim', [minX maxX]);
