% yaxshift.m:  Shift all the data lines in an axis.
% Usage: yaxshift( howMuch );
% Where 'howMuch' is the amount to shift the data.  Positive values shift the data
% up; negative values shift the data down.

% Written by:  Jonathan Jacobs
%              April 1998 (last mod:  04/02/98)

function xaxshift(howMuch);

if nargin == 0
   help xaxshift
   return
end

figwind = findHotW;
figure(figwind)

ga = gca;
gf = gcf;

if strcmp(get(gf,'Tag'), 'zoomed window')
   disp('xAxShift can''t operate while ZOOMTOOL is active')
   return
end

temp = get(ga,'Children');

count=1;
for i=1:length(temp)
   if strcmp(get(temp(i),'Type'),'line')
      lineList(count)=temp(i);
      count = count+1;
   end
end

minY=1000000;
maxY=-1000000;
for i=1:length(lineList)
   y=get(lineList(i),'YData');
   y=y+howMuch;
   minY=min(minY,min(y));
   maxY=max(maxY,max(y));
   set(lineList(i),'YData',y);
end

set(gca,'YLim', [minY maxY]);
