% getcurxy.m:  Returns the sample index and y-value of the
% selected cursor.

% Written by: Peggy Skelly and Jonathan Jacobs
%             (last mod: 04/19/07)

function [x,y,t,zoom_first_x] = getcurxy(ga,cursor)
%  getcurxy is used by zoomtool modified by p skelly to 
%  get data points corresponding to the cursor(s).

% find parent window
gf = get(ga,'Parent');

% get some data about the current axes state
zoom_xfactor = get(get(ga,'xlabel'),'UserData');
zoom_xxlim = get(ga,'Xlim');
zoom_xmin = zoom_xxlim(1);

% get line data
zoom_yH = findline(ga,'zoomed');
zoom_y = get(zoom_yH,'YData');

% find 1st time index
temp = get(zoom_yH,'XData');
zoom_first_x = temp(1);

debug=0;

% get current vertical cursor locations
if cursor == 1
   t = crsrloc(ga,1001);
 else
   t = crsrloc(ga,2001);
end;

if t <= zoom_xxlim(1)+100*eps, t = zoom_xxlim(1); end;
if t >= zoom_xxlim(2)-100*eps, t = zoom_xxlim(2); end;

% calculate current index
x = round((t-zoom_first_x)/zoom_xfactor)+1;
%x = round(t/zoom_xfactor);

if x > length(zoom_y), x=length(zoom_y); end

% current point locations
if debug
   disp([ 't=' num2str(t) '   x=' num2str(x) ])
end

%%% old code.  may have 'off by one' errors
% get x data to find index 
%x = get(findline(ga,'zoomed'),'XData');
% find the place where XData = t
%[m,n] = find( x >= t );
% return the first index number as x
%x = n(1);

% get current horizontal cursor locations 
% (representing the vertical data values)
if cursor == 1
   y = crsrloc(ga,1002);
 else
   y = crsrloc(ga,2002);
end;

y_calc = zoom_y(x);
if debug, 
   disp(['y cursor = ' num2str(y) '   y calc = ' num2str(y_calc)])
end

if y ~= y_calc
   disp('  Warning in ''getcurxy.m'': y (cursor) ~= y (calc)')
   disp('   Make sure you are using Cursor One.')
end