% rbzoom.m: checks state of button, changes text when toggled,
% turns 'zoom' on or off, and calls 'autorange_y, newlims' to
% update when the zoom is done

% Written by:  Jonathan Jacobs
% October 2003 - February 2010 (last mod: 02/09/10)

function rbzoom(cmd)

state = get(gco,'Value');

switch lower(cmd)
   case {'zoom'}
		switch state
		  case 0,
			set(gco,'String','Off');
			zoom off
			newlims     
			
		  case 1,
			set(gco,'String','On');
			xlims=get(gca,'xlim');
			ylims=get(gca,'ylim');
			set(gco,'UserData',[xlims ylims])
			zoom reset
			zoom on
			newlims
		end
	case {'reset'}	
		hRBzoom = get(gco,'UserData');
		axlims = get(hRBzoom,'UserData');
		if isempty(axlims)
			return
		end
		set(gca,'Xlim',[axlims(1) axlims(2)])
		set(gca,'Ylim',[axlims(3) axlims(4)])
		newlims
end
