% whackLin.m: take the current axis and tell what children it has.
% Then it lets you whack out one or more.  To remove a range of objects
% type the first one, a dash, and the final one.  eg: '1-4'
% WARNING: it's not a good idea to run this on a ZOOMTOOL figure
% because it might delete objects that ZOOMTOOL assumes will still be there.
% Written by:  Jonathan Jacobs
%              July 1996  (last mod: 07/03/96)

function whack( dummy )

childList = get(gca, 'Child');

disp( ['     Type   Size       UserData'] )
if length(childList) == 0
   disp( '   >> No graph objects found <<' )
   disp( ' ' )
   return
end

for i=1:length(childList)
   objType  = get(childList(i), 'Type');
   objXDSiz = mat2str( size(get(childList(i), 'Xdata')) );
   objUsrD  = mat2str( get(childList(i), 'UserD') );
   if strcmp(objUsrD, '[]'),
      objUsrD = [objUsrD, '  '];
   end
   if strcmp(objUsrD(2:3), '00')
      id = '(Cursor)';
    else
      id = '';
   end
   objXDSiz = [objXDSiz blanks(8 - length(objXDSiz))];
   numStr = [blanks(2-length(num2str(i))) num2str(i)];
   disp( [numStr '.  ' objType '   ' objXDSiz '   ' objUsrD '  ' id] )   
end

i = [];
while( isempty(i) ) 
   i=input('Whack who? (''0'' to quit): ', 's');
end

[arg1 rest] = strtok(i, ['-' ';' ':' ',']);
arg1 = str2num(arg1);
arg3 = arg1;

if rest ~= []
   [arg2 rest] = strtok( rest, ['0' '1' '2' '3' '4' '5' '6' '7' '8' '9'] );
end

if rest ~= []
   [arg3] = strtok( rest, ['-' ';' ':' ','] );
   arg3 = str2num(arg3);
end

if arg1 == 0, return; end
for i = arg1: arg3
   delete(childList(i))
end
